﻿namespace OwinDemo
{
    using System;
    using System.Collections.Generic;
    using System.Threading.Tasks;
    using Owin.Types;

    using AppFunc = System.Func<System.Collections.Generic.IDictionary<string, object>, System.Threading.Tasks.Task>;

    public class AboutModule
    {
        private readonly AppFunc _next;

        public AboutModule(AppFunc next)
        {
            if (next == null)
                throw new ArgumentNullException("next");

            this._next = next;
        }

        public Task Invoke(IDictionary<string, object> env)
        {
            try {
                var request = new OwinRequest(env);
                var path = request.Path.TrimEnd(new[] { '/' });

                if (path.Equals("/About", StringComparison.OrdinalIgnoreCase)) {
                    var response = new OwinResponse(env);
                    return response.WriteAsync("About page");
                }
            }
            catch (Exception ex) {
                var tcs = new TaskCompletionSource<object>();
                tcs.SetException(ex);
                return tcs.Task;
            }

            return this._next(env);
        }
    }
}