﻿namespace OwinDemo
{
    using System.Collections.Generic;
    using System.Text;
    using Owin;

    using AppFunc = System.Func<System.Collections.Generic.IDictionary<string, object>, System.Threading.Tasks.Task>;

    public class Startup
    {
        public void Configuration(IAppBuilder appBuilder)
        {
            appBuilder.Use(typeof(LoggerModule), "Log Module >");
            appBuilder.UseHandler(HomePageModule.ShowMainPage);
            appBuilder.Use(typeof(AboutModule));

            appBuilder.Properties["builder.DefaultApp"] = new AppFunc(
                env => {
                    var headers = (IDictionary<string, string[]>)env["owin.ResponseHeaders"];
                    headers.Add("Content-Type", new[] { "text/plain; charset=utf-8" });

                    var outstream = (System.IO.Stream)env["owin.ResponseBody"];
                    var buffer = Encoding.UTF8.GetBytes("Извините, но запрошенный адрес не существует.");
                    return outstream.WriteAsync(buffer, 0, buffer.Length);
                });
        }
    }
}